//Made by Jon
//	Special thanks: 
//  Ash, Varren, Milk and others from the SRB2 Discord for giving me feedback on things
//	Xelork, Chris, Ano, Monopoli, Hezi, Talis and all the others who helped me test the mod and sent me plenty of ideas
//	Monster Iestyn and Golden for helping me figure out how the drowning numbers could work and resolving a hard coded issue with custom character statues

//freeslotting stuff and adding sfx info
freeslot("MT_PELOBOOM", "MT_STATUE", "MT_THOLE", "sfx_pelo", "sfx_cutg", "sfx_coug", "sfx_chtw", "s_laff1", "SPR_LAFF")

//Sfx stuff. mainly for changing captions and dictating how far noises are heard from
sfxinfo[sfx_pelo] = {
		caption = "BOOM!",
        singular = false,
        priority = 64,
        flags = SF_X8AWAYSOUND
}

sfxinfo[sfx_coug] = {
		caption = "Weak cough",
        singular = false,
        priority = 64,
}

sfxinfo[sfx_cutg] = {
		caption = "High pitched scream",
        singular = false,
        priority = 64,
        flags = SF_X4AWAYSOUND
}

sfxinfo[sfx_chtw] = {
		caption = "Goodbye...",
        singular = false,
        priority = 64,
}

//States copying boss fang's laugh with some tweaks
states[S_LAFF1] = {
		sprite = SPR_LAFF,
		frame = FF_ANIMATE|A,
		tics = states[S_FANG_WAIT1].tics,
		action = states[S_FANG_WAIT1].action,
		var1 = states[S_FANG_WAIT1].var1,
		var2 = states[S_FANG_WAIT1].var2,
		nextstate = S_PLAY_STND
}

//Sfx captions for sounds that go unused in vanilla
sfxinfo[sfx_cdfm64].caption = "Fall damage"
sfxinfo[sfx_kc68].caption = "Petrification"
sfxinfo[sfx_kc40].caption = "Strong impact"
sfxinfo[sfx_s23b].caption = "Tiring out"
sfxinfo[sfx_s23d].caption = "Releasing wall"

//List of death messages
local speedDeath = {" built up too much speed and misaligned their QPUs", " accelerated beyond this mortal coil", " did their best sanec impression"}
local ringDeath = {"'s kidneys are now worth 10x as much", " became a tacky decoration piece", "'s greed got the better of them", " was touched by King Midas"}
local gravDeath = {" took the Newton express", " decided to visit the mole people", " face planted into the afterlife"}
//local superDeath = {" chuckles. 'You mean the chaos emeralds?'", " learned, but forgot to live", " opened their heart, it was not alright"}
local airDeath = {" forgot to poke a hole in their shield", "'s lungs are now a pair of raisins", " realized extreme gears aren't the only things that need air"}
local boredomDeath = {" ascended to a higher plane of existence", " is outta here!", " went out to buy cigarettes"}

//Lists for sorting things
local FDEnabled = {S_PLAY_JUMP,S_PLAY_BOUNCE_LANDING,S_PLAY_FALL,S_PLAY_FLY,S_PLAY_FLY_TIRED,S_PLAY_WALK,S_PLAY_SKID,S_PLAY_ROLL,S_PLAY_GLIDE,S_PLAY_GLIDE_LANDING} //states that can receive fall damage
local NBEnabled = {SH_PITY, SH_ARMAGEDDON, SH_PINK, SH_ATTRACT, SH_ELEMENTAL, SH_BUBBLEWRAP, SH_FORCE} //shields that don't allow players to breathe
local bullyList = {} //bullied characters list. tails was originally here by default since this used to be "Tails Bullying" at first

//easy var changing for lots of stuff
local minFall = -16*FRACUNIT //light fall damage threshold. Def -17*FRACUNIT
local maxFall = -27*FRACUNIT //fall damage death threshold. Def -27*FRACUNIT
local timeBeforeBoom = 11 //how many tics to wait before blowing a player up due to excessive speed. Def 11
local maxFlight = 80 //how long a nerfed tails can fly. Def 80
local maxSpeed = 18*FRACUNIT //max speed a nerfed character can run at. Def 18*FRACUNIT
local deathTics = 9*TICRATE //determines at what points death texts appear on screen and when someone dies. Def 12*TICRATE
local thokForce = 8 //how strong or weak a thok is. Def 8
local glideSpeed = 5 //how fast knuckles can glide. Def 5
local maxClimb = 12*TICRATE //how long knuckles can climb and glide for. he can climb for half as long as he can glide. Def 6*TICRATE
local maxFloat = 2*TICRATE //how long metal sonic can float for. Def 2*TICRATE
local maxBounce = 14*FRACUNIT //fang's maximum bounce vertical momentum
local boredomTimer = 27*TICRATE //how long a player has to be in a waiting state before dying of boredem
local thokHeight = 4*FRACUNIT //how high sonic's nerfed thok will take him on use

local mapFailsafe = false //because erz1 and acz1 are impossible as sonic and fang respectively

//bullying death scene function. makes players invisible and invincible while text appears.
//if you want objects created on death (ie. the golden statues) to be deleted, set p.delObj to true when toggling p.idied
//p.delObj is false by default
local function youAreDead(p)
	//first section: locking a player in place and ensuring they don't die, can't be carried and can't change characters
	if p.dontRemoveShield ~= true then
		P_RemoveShield(p)
	end
	p.rings = 0
	p.mo.momx = 0
	p.mo.momy = 0
	p.mo.momz = 0
	p.mo.flags = $ | MF_NOCLIP
	p.pflags = $ | PF_FULLSTASIS | PF_JUMPED | PF_THOKKED | PF_GODMODE
	p.pflags = $ & ~PF_CANCARRY
	p.mo.state = S_INVISIBLE
	p.powers[pw_ignorelatch] = 32768
	p.powers[pw_carry] = 0
	//second section: using timers to define when text will appear on screen
	p.texTimer = $+1
	if p.texTimer > deathTics/4 then
		p.firstmessage = true
	end
	if p.texTimer > deathTics/2 then
		P_RestoreMusic(p)
		p.secondmessage = true
	end
	//third section: when the timer ends, remove special player flags and (if enabled) delete death objects, then kill players
	if p.texTimer > deathTics then
		p.idied = false
		p.pflags = $ & ~PF_FULLSTASIS & ~PF_JUMPED & ~PF_THOKKED & ~PF_GODMODE
		p.mo.flags = $ & ~MF_NOCLIP
		if p.skin == "tails" then
			p.pflags = $ | PF_CANCARRY
		end
		p.powers[pw_ignorelatch] = 0
		p.firstmessage = false
		p.secondmessage = false
		p.texTimer = 0
		p.dontRemoveShield = nil
		if p.deathObj and p.deathObj.valid and p.delObj then
			p.delObj = false
			p.deathObj.state = S_NULL
			p.deathObj = nil
		end
		P_DamageMobj(p.mo, nil, nil, 420, DMG_INSTAKILL)
	end
end

//Checking if your current skin is in the bully list
local function amIBullied(myskin)
	for i, skin in ipairs(bullyList) do
		if myskin == skin then
			return true
		end
	end
	return false
end

//death conditions, var initialization and things that happen every tic go here
local function bullyThinker(p)
	if not p.mo then return end
	//Cleaning things on map change
	//p.cleanup is brought from the map change hook
	if p.cleanup then
		if not p.mo then return end
		p.idied = false
		p.pflags = $ & ~PF_FULLSTASIS & ~PF_JUMPED & ~PF_THOKKED & ~PF_GODMODE
		if p.skin == "tails" then
			p.pflags = $ | PF_CANCARRY
		end
		p.mo.state = S_PLAY_STND
		p.firstmessage = false
		p.secondmessage = false
		p.texTimer = 0
		if p.deathObj then
			if p.deathObj.valid then p.deathObj.state = S_NULL end
			p.deathObj = nil
		end
		p.powers[pw_ignorelatch] = 0
		p.dontRemoveShield = nil
		p.shieldDrown = nil
		p.checkedShield = false
	end
	p.cleanup = nil
	
	//Most of the bullying script is here
	if amIBullied(p.mo.skin) then
		//Initializing stuff
		if p.delObj == nil then p.delObj = false end
		if p.checkedShield == nil then p.checkedShield = false end
		if p.texTimer == nil then p.texTimer = 0 end
		if p.lastmomz == nil then p.lastmomz = 0 end
		if p.peloTimer == nil then p.peloTimer = 0 end
		if p.msg1 == nil then p.msg1 = "you died from ligma" end
		if p.msg2 == nil then p.msg2 = skins[p.mo.skin].realname .. " caught ligma and died" end
		
		//preventing the script from iterating through shields every tic
		//also resets shield drowning values upon losing a shield
		if p.powers[pw_shield] == 0 and p.checkedShield == true then
			p.shieldDrown = nil
			p.checkedShield = false
		end
		
		//Preventing space drowning in the metal sonic race
		//While making metal sonic blow up would be infinitely more amusing, MT_METALJETFUME is pretty much integrated into the metal sonic race demo.
		//Meaning that even if metal sonic is deleted, his jet trail sticks around forever which looks far too silly to ignore
		if gamemap == 25 then
			p.powers[pw_spacetime] = 9000
		end
		
		//Adding some tweaks to otherwise unwinnable or incredibly bothersome maps for fang, amy and sonic
		if ((gamemap == 13 and mapheaderinfo[gamemap].lvlttl == "Arid Canyon") 
		or (gamemap == 14 and mapheaderinfo[gamemap].lvlttl == "Arid Canyon") 
		or (gamemap == 22 and mapheaderinfo[gamemap].lvlttl == "Egg Rock") 
		or (gamemap == 31 and mapheaderinfo[gamemap].lvlttl == "Pipe Towers") 
		or (gamemap == 41 and mapheaderinfo[gamemap].lvlttl == "Aerial Garden")) and (not mapFailsafe) then
			mapFailsafe = true
			if gamemap == 22 then //ERZ1
				P_SpawnMobj(6443*FRACUNIT, -3875*FRACUNIT, 0, MT_YELLOWSPRING)
			elseif gamemap == 13 then //ACZ1
				local sign = P_SpawnMobj(423*FRACUNIT, -12728*FRACUNIT, 2088*FRACUNIT, MT_ARIDSIGN_CAUTION)
				sign.flags = $|MF_NOCLIPHEIGHT|MF_NOGRAVITY
				sign.z = $-6*FRACUNIT
				sign.angle = ANGLE_225
				P_SpawnMobj(-7572*FRACUNIT, -701*FRACUNIT, 3968*FRACUNIT, MT_WHIRLWIND_GOLDBOX)
			elseif gamemap == 14 then //ACZ2
				P_SpawnMobj(7711*FRACUNIT, -6562*FRACUNIT, 2784*FRACUNIT, MT_WHIRLWIND_GOLDBOX)
			elseif gamemap == 31 then //PTZ
				P_SpawnMobj(4230*FRACUNIT, 5952*FRACUNIT, 960*FRACUNIT, MT_BLUESPRING)
				P_SpawnMobj(4160*FRACUNIT, 5952*FRACUNIT, 960*FRACUNIT, MT_BLUESPRING)
				P_SpawnMobj(4090*FRACUNIT, 5952*FRACUNIT, 960*FRACUNIT, MT_BLUESPRING)
				P_SpawnMobj(4160*FRACUNIT, 5882*FRACUNIT, 960*FRACUNIT, MT_BLUESPRING)
				P_SpawnMobj(4160*FRACUNIT, 6022*FRACUNIT, 960*FRACUNIT, MT_BLUESPRING)
			elseif gamemap == 41 then //AGZ
				P_SpawnMobj(11270*FRACUNIT, -18969*FRACUNIT, 220*FRACUNIT, MT_WHIRLWIND_GOLDBOX)
			end
		end
		
		//allowing non-super characters to go super to enable super death
		//if All7Emeralds(emeralds) and not (p.charflags & SF_SUPER) then
			//p.charflags = $ | SF_SUPER
		//end
		
		//you are dead! run this every tic
		if p.idied and p.mo.state == S_PLAY_DEAD then
			p.idied = false
		end
		if p.idied then
			youAreDead(p)
		end
		
		//Making sure zoom tubes and other things aren't a guaranteed death sentence for speed limits
		//We'll give players a 1 second grace timer after leaving a zoom tube before the explosion countdown begins
		if p.powers[pw_carry] == CR_ZOOMTUBE or p.powers[pw_carry] == CR_ROPEHANG then
			p.zoomForgiveness = TICRATE
		end
		if p.zoomForgiveness ~= nil and p.zoomForgiveness > 0 then
			p.zoomForgiveness = $-1
		end
		//Extra forgiving version for CEZ maces to allow otherwise impossible jumps
		if p.powers[pw_carry] == CR_MACESPIN or p.powers[pw_carry] == CR_DUSTDEVIL or p.powers[pw_carry] == CR_ROLLOUT then
			p.superForgiveness = true
		end
		if (P_IsObjectOnGround(p.mo) or p.pflags & PF_THOKKED) and p.superForgiveness == true then
			if p.speed >= maxSpeed then 
				p.mo.momx = $/2
				p.mo.momy = $/2
			end
			p.superForgiveness = false
		end
		
		//Debuffs and changed mechanics
		//Sonic -- nerf thok massively and give it a small aerial boost in ability hook to let him avoid some otherwise lethal fall damage
		if p.mo.skin == "sonic" then
			p.actionspd = thokForce*FRACUNIT
		end
		//Tails -- reduced flight
		if p.powers[pw_tailsfly] > 275 then p.powers[pw_tailsfly] = maxFlight end
		//Knuckles -- reduced glide speed and added climb tiring mechanic
		if p.mo.skin == "knuckles" then
			p.actionspd = glideSpeed*FRACUNIT
			if p.mo.state == S_PLAY_CLIMB or p.mo.state == S_PLAY_CLING or p.mo.state == S_PLAY_GLIDE or p.mo.state == S_PLAY_SWIM then
				if p.climbtired == nil then p.climbtired = 0 end
				if p.climbtired < maxClimb then
					if p.mo.state == S_PLAY_GLIDE or p.mo.state == S_PLAY_SWIM then 
						p.climbtired = $+2
					else
						p.climbtired = $+4
					end
					if p.climbtired%(maxClimb/2) == 0 then S_StartSound(p.mo, sfx_s23b) end
					if p.climbtired >= maxClimb then
						p.charability = CA_NONE
						S_StartSound(p.mo, sfx_s23d)
					end
				end
			end
			if P_IsObjectOnGround(p.mo) then
				p.charability = CA_GLIDEANDCLIMB
				p.climbtired = nil
			end
		end
		//Amy -- Hammer swings at springs make amy enter a helpless state, rendering vertical springs useless but making diagonal ones (which are needed) actually useful
		if p.mo.skin == "amy" then 
			if (P_IsObjectOnGround(p.mo) and p.helpless) or p.helplesslimit == 8*TICRATE then
				p.helpless = nil
				p.helplesslimit = nil
				p.pflags = $ & ~PF_FULLSTASIS
			end
			if p.mo.eflags & MFE_SPRUNG and p.LSMelee then
				p.helpless = true
			end
			if p.helpless then
				if p.helplesslimit == nil then p.helplesslimit = 0 end
				p.helplesslimit = $+1
				p.pflags = $ | PF_FULLSTASIS
				p.mo.state = S_PLAY_PAIN
			end
		end
		//Fang -- laughs after every hit shot. maximum bounce height is severely nerfed
		if p.mo.skin == "fang" then
			if p.mo.state == S_PLAY_BOUNCE and p.mo.momz >= maxBounce and P_MobjFlip(p.mo) == 1 then
				P_SetObjectMomZ(p.mo, maxBounce-FRACUNIT)
			elseif p.mo.state == S_PLAY_BOUNCE and p.mo.momz <= maxBounce*-1 and P_MobjFlip(p.mo) == -1 then
				P_SetObjectMomZ(p.mo, maxBounce-FRACUNIT)
			end
			if p.startlaff then 
				p.pflags = $ | PF_FULLSTASIS | PF_JUMPED
				p.mo.flags = $ | MF_NOGRAVITY
				p.powers[pw_ignorelatch] = 32768
			end
			if p.startlaff and (p.mo.state == S_PLAY_STND or p.mo.state == S_LAFF1 or p.mo.state == S_PLAY_EDGE or p.mo.state == S_PLAY_PAIN) then
				if p.rotx then
					p.mo.z = $+1
					p.mo.state = S_LAFF1
					p.laffangle = R_PointToAngle2(p.mo.x, p.mo.y, p.rotx, p.roty)
					p.rotx = nil
					p.roty = nil
				end
				if p.lafftimer == nil then p.lafftimer = 0 end
				p.lafftimer = $+1
				if p.laffangle then
					p.drawangle = p.laffangle
				end
				if p.lafftimer >= 70 then
					p.powers[pw_ignorelatch] = 0
					p.pflags = $ & ~PF_FULLSTASIS & ~PF_JUMPED
					p.mo.flags = $ & ~MF_NOGRAVITY
					p.mo.state = S_PLAY_STND
					p.laffangle = nil
					p.lafftimer = nil
					p.startlaff = nil
				end
			end
		end
		//Metal Sonic -- Limited flight and "spam prevention" so metal can't extend his flight like silver in 06
		if p.mo.skin == "metalsonic" then
			if p.mo.state == S_PLAY_FLOAT or p.mo.state == S_PLAY_FLOAT_RUN then
				if p.floattired == nil then p.floattired = 0 end
				if p.floattired < maxFloat then
					p.floattired = $+1
					if p.floattired%(maxFloat/3) == 0 then
						local exp = P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height/2, MT_BOSSEXPLODE)
						exp.spritexscale = $/2
						exp.spriteyscale = $/2
						S_StartSound(p.mo, sfx_cybdth)
					end
					if p.floattired == maxFloat then
						S_StartSound(p.mo, sfx_s3k51)
						p.secondjump = 2
						p.mo.state = S_PLAY_FALL
						p.charability = CA_NONE
					end
				end
			end
			if P_IsObjectOnGround(p.mo) then
				p.charability = CA_FLOAT
				p.floattired = nil
			end
		end
		
		//Global speed debuff
		if p.superForgiveness then
			p.normalspeed = skins[p.mo.skin].normalspeed
		else
			p.normalspeed = maxSpeed
		end
		
		//Too little air (no air inside shield)
		if p.powers[pw_shield] and p.checkedShield == false then
			for i, shield in ipairs(NBEnabled) do
				if p.powers[pw_shield] == shield or p.powers[pw_shield] & SH_FORCE then
					p.shieldDrown = 1050//same as underwater timer
					break
				end
			end
			p.checkedShield = true
		end
		if p.shieldDrown ~= nil and p.shieldDrown > 30 then
			p.shieldDrown = $-1
			if p.shieldDrown == 875 or p.shieldDrown == 700 or p.shieldDrown == 525 then
				S_StartSound(p.mo, sfx_wtrdng)
			end
			if p.shieldDrown ~= 30 and p.shieldDrown <= 420 and p.shieldDrown%70 == 0 then
				local drownStates = {S_ZERO1, S_ONE1, S_TWO1, S_THREE1, S_FOUR1, S_FIVE1}
				local drown = P_SpawnMobjFromMobj(p.mo, 0, 0, FRACUNIT, MT_DROWNNUMBERS)
				S_StartSound(p.mo, sfx_dwnind)
				drown.state = drownStates[p.shieldDrown/70]
				drown.shieldDrown = p.shieldDrown
				drown.target = p.mo
			end
			if p.shieldDrown == 30 and not p.idied then
				local clone = P_SpawnMobjFromMobj(p.mo,0,0,0,MT_PLAYER)
				clone.skin = p.mo.skin
				clone.color = p.mo.color
				clone.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
				P_KillMobj(clone)
				p.mo.state = S_INVISIBLE
				p.msg1 = "you ran out of air"
				p.msg2 = skins[p.mo.skin].realname .. " couldn't breathe inside the shield"
				print("\3 \133" .. p.name .. airDeath[P_RandomRange(1, #airDeath)])
				p.idied = true
			end
		end
		
		//Too harsh of a fall
		//two variations: simple damage from a short fall and guaranteed death from a large fall
		if (not p.zoomForgiveness) then
			if (p.lastmomz <= minFall and p.lastmomz > maxFall) and P_IsObjectOnGround(p.mo) and p.canReceiveFD and not P_CheckDeathPitCollide(p.mo) then
				S_StartSound(p.mo, sfx_cdfm64)
				P_DamageMobj(p.mo, nil, nil, 1, 0)
			elseif p.lastmomz <= maxFall and P_IsObjectOnGround(p.mo) and p.canReceiveFD and not P_CheckDeathPitCollide(p.mo) then
				p.mo.state = S_INVISIBLE
				p.msg1 = "you fell too far"
				p.msg2 = skins[p.mo.skin].realname .. " couldn't handle the fall"
				S_StartSound(p.mo, sfx_crumbl)
				P_StartQuake(6*FRACUNIT, 15)
				p.deathObj = P_SpawnMobjFromMobj(p.mo, 0, 0, FRACUNIT, MT_THOLE)
				p.deathObj.spritexscale = FRACUNIT*3
				p.deathObj.spriteyscale = FRACUNIT*2
				p.deathObj.z = $ - FRACUNIT*7
				print("\3 \133" .. p.name .. gravDeath[P_RandomRange(1, #gravDeath)])
				p.idied = true
			end
		end
		
		local function tryGetGlobal(name)
			local success, res = pcall(do return _G[name] end)

			return success and res or nil
		end
		
		//Too many rings
		//Disabled during special stages
		if p.rings >= 20 and not G_IsSpecialStage(gamemap) then
			p.msg1 = "you got too many rings"
			p.msg2 = skins[p.mo.skin].realname .. " became a golden statue"
			p.rings = 0
			p.delObj = true
			S_StartSound(p.mo, sfx_kc68)
			p.deathObj = P_SpawnMobjFromMobj(p.mo, 0, 0, FRACUNIT, MT_STATUE)
			P_SetObjectMomZ(p.deathObj, 8*FRACUNIT, false)
			local v = p.mo.skin:sub(0,3)
			v = v:upper(v)
			if not (tryGetGlobal("S_" .. v .. "T")) then
				p.deathObj.skin = p.mo.skin
				p.deathObj.colorized = true
				p.deathObj.color = SKINCOLOR_GOLD
				p.deathObj.state = S_PLAY_PAIN
			else
				p.deathObj.state = _G["S_" .. v .. "T"]
			end
			p.mo.z = $+FRACUNIT
			print("\3 \133" .. p.name .. ringDeath[P_RandomRange(1, #ringDeath)])
			p.idied = true
		end
		
		//Too powerful (went super)
		//if p.superTimer ~= nil and p.superTimer < 90 then
			//p.superTimer = $+1
			//if p.superTimer%2 == 0 then
				//P_TeleportMove(p.mo, p.mo.x+P_RandomRange(-8, 8)*FRACUNIT, p.mo.y+P_RandomRange(-8, 8)*FRACUNIT, p.mo.z+P_RandomRange(-8, 8)*FRACUNIT)
			//else
				//P_TeleportMove(p.mo, p.myLocationX, p.myLocationY, p.myLocationZ)
			//end
			//if p.superTimer >= 31 then
				//p.myLocationX = nil
				//p.myLocationY = nil
				//p.myLocationZ = nil
				//p.superTimer = nil
				//p.msg1 = "you became too powerful"
				//p.msg2 = skins[p.mo.skin].realname .. " could not handle the emeralds' energy"
				//p.rings = 0
				//S_StartSound(p.mo, sfx_pelo)
				//P_StartQuake(6*FRACUNIT, 9)
				//local peloboom = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_PELOBOOM)
				//peloboom.spritexscale = FRACUNIT/3
				//peloboom.spriteyscale = FRACUNIT/3
				//print("\3 \133" .. p.name .. superDeath[P_RandomRange(1, #superDeath)])
				//p.idied = true
			//end
		//end
		
		//Too bored
		if p.mo.state == S_PLAY_WAIT and not p.goodbye then
			if p.changetheworld == nil then p.changetheworld = 0 end
			p.changetheworld = $+1
			if p.changetheworld == boredomTimer then
				p.changetheworld = nil
				p.goodbye = true
				P_SpawnGhostMobj(p.mo)
				S_FadeOutStopMusic(250, p)
				p.mo.flags = $ | MF_NOGRAVITY
				p.mo.state = S_INVISIBLE
				p.mo.z = $+1
				S_StartSound(p.mo, sfx_chtw)
			end
		end
		if p.changetheworld and p.mo.state ~= S_PLAY_WAIT then
			p.changetheworld = nil
		end
		if p.goodbye then
			if p.transp == nil then p.transp = 0 end
			p.pflags = $ | PF_FULLSTASIS | PF_JUMPED | PF_THOKKED | PF_GODMODE
			p.pflags = $ & ~PF_CANCARRY
			p.powers[pw_ignorelatch] = 32768
			p.transp = nil
			p.goodbye = nil
			p.msg1 = "you took too long"
			p.msg2 = skins[p.mo.skin].realname .. " became too bored and vanished"
			p.idied = true
			print("\3 \133" .. p.name .. boredomDeath[P_RandomRange(1, #boredomDeath)])
		end
		
		//Too fast
		if (not p.superForgiveness) and (not p.helpless) and (not p.idied) then
			if p.speed/FRACUNIT > 28 and (p.powers[pw_carry] ~= CR_ZOOMTUBE or p.powers[pw_carry] == CR_MACESPIN or p.powers[pw_carry] == CR_ROPEHANG) and (p.zoomForgiveness == nil or p.zoomForgiveness == 0) then
				if p.peloTimer < timeBeforeBoom then
					p.peloTimer = $+1
					if p.peloTimer == timeBeforeBoom then
						p.msg1 = "you went too fast"
						p.msg2 = skins[p.mo.skin].realname .. " caught on fire and exploded"
						S_StartSound(p.mo, sfx_pelo)
						P_StartQuake(6*FRACUNIT, 9)
						local peloboom = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_PELOBOOM)
						peloboom.spritexscale = FRACUNIT/3
						peloboom.spriteyscale = FRACUNIT/3
						p.mo.z = $+FRACUNIT
						p.delObj = true
						p.idied = true
						print("\3 \133" .. p.name .. speedDeath[P_RandomRange(1, #speedDeath)])
					end
				end
			else 
				//Just so speed death isn't instant
				p.peloTimer = 0
			end
		end
		
		//tic end state checked for twinspin or melee spring bounces
		if p.mo.state == S_PLAY_TWINSPIN or p.mo.state == S_PLAY_MELEE or p.mo.state == S_PLAY_MELEE_FINISH or p.mo.state == S_PLAY_MELEE_LANDING then
			p.LSMelee = true
		else
			p.LSMelee = false
		end
		
		//tic end vars to be used in the next tic
		p.lastmomz = p.mo.momz
		p.laststate = p.mo.state
		
		//tic end state checker for fall damage
		for i, state in ipairs(FDEnabled) do
			if p.mo.state == state then
				p.canReceiveFD = true
				break
			else 
				p.canReceiveFD = false 
			end
		end
		if (gamemap == 27 or gamemap == 26) and (mapheaderinfo[gamemap].lvlttl == "Black Core") then p.canReceiveFD = false end //Making sure players survive the ERZ2 and ERZ3 falls
	end
end

//Death by going super
//Currently in limbo due to bugs and not being very intuitive

//local function superDeath(p)
	//if amIBullied(p.mo.skin) == false then return end
	//print(p.laststate)
	//print(p.mo.state)
	//if p.rings >= 15 and All7Emeralds(emeralds) and (not p.powers[pw_carry]) then
		//S_StartSound(p.mo, sfx_cutg)
		//P_DoSuperTransformation(p, false)
		//p.superTimer = 0
		//p.myLocationX = p.mo.x
		//p.myLocationY = p.mo.y
		//p.myLocationZ = p.mo.z
	//end
//end

//Making statues produce some dust in a circle and a small quake when falling
local function statueThinker(stat)
	if P_IsObjectOnGround(stat) and stat.touchedGround == nil then
		local angles = 8
		local angle = 0
		for i = 0, angles - 1 do
			angle = FixedAngle(360*FRACUNIT/angles)*i
			local dust = P_SpawnMobjFromMobj(stat, 10*cos(angle), 10*sin(angle), 0, MT_SPINDUST)
			dust.momx = 8 * cos(angle)
			dust.momy = 8 * sin(angle)
		end
		S_StartSound(stat, sfx_kc40)
		P_StartQuake(4*FRACUNIT, 9)
		stat.touchedGround = true
	end
end

//Custom drowning numbers for drowning above water
//pretty much everything here is a copy from the original MT_DROWNNUMBERS in the source code
//but ported to lua to remove the "underwater or in space only" restriction
local function newNumberThinker(numb)
	if numb.shieldDrown ~= nil then
		if numb.lifetics == nil then numb.lifetics = 40 end
		if not numb.target then
            P_RemoveMobj(numb)
            return true
        end
        if not numb.target.player then
            P_RemoveMobj(numb)
            return true
        end
		P_TeleportMove(numb, numb.target.x, numb.target.y, numb.z)
		numb.destscale = numb.target.destscale
		P_SetScale(numb, numb.target.scale)
		if numb.target.eflags & MFE_VERTICALFLIP then
			numb.z = numb.target.z - FixedMul(16*FRACUNIT, numb.target.scale) - numb.height
			if numb.target.player.pflags & PF_FLIPCAM then
				numb.eflags = $ | MFE_VERTICALFLIP
			end
		else
			numb.z = numb.target.z + (numb.target.height) + FixedMul(8*FRACUNIT, numb.target.scale) // Adjust height for height changes
		end
		if numb.threshold <= 35 then
			numb.flags2 = $ | MF2_DONTDRAW
		else
			numb.flags2 = $ & ~MF2_DONTDRAW
		end
		if numb.threshold <= 30 then
			numb.threshold = 40
		end
		numb.threshold = $-1
		numb.lifetics = $-1
		if numb.lifetics == 0 then numb.target = nil end
		return true
	end
	return false
end

//Preventing invisible players from damaging things
local function preventDamage(p, mob)
	if not p.mo then return end
	if amIBullied(p.mo.skin) and p.idied then
		return false
	end
end

//Preventing leaving players from causing errors (hopefully)
local function dontBreakAnything(p, reason)
	if not p.mo then return end
	p.idied = false
	p.pflags = $ & ~PF_FULLSTASIS & ~PF_JUMPED & ~PF_THOKKED & ~PF_GODMODE
	p.firstmessage = false
	p.secondmessage = false
	p.texTimer = 0
	if p.deathObj and p.deathObj.valid then
		p.delObj = false
		p.deathObj.state = S_NULL
		p.deathObj = nil
	end
end

//Preventing players from carrying over their deaths into the next map
local function mapchangeAntideath(mapnum)
	for p in players.iterate do
		if not p.mo then return end
		p.cleanup = true
	end
	mapFailsafe = false
end

//Allowing server admins to determine who gets bullied
local function bullySync(net)
	mapFailsafe = net(mapFailsafe)
	bullyList = net(bullyList)
end

//(mostly) Per-skin charability tweaking
local function abilityBullying(p)
	if p and p.mo and p.mo.valid and amIBullied(p.mo.skin) then
		if p.mo.skin == "sonic" and not (p.pflags & PF_THOKKED) then
			S_StartSound(p.mo, sfx_coug)
			P_SetObjectMomZ(p.mo, thokHeight, false)
		end
		if p.mo.skin == "metalsonic" and not (p.secondjump == 2) then
			if p.floattired and p.floattired ~= 0 then 
				p.floattired = $+6
				if p.floattired > maxFloat then
					S_StartSound(p.mo, sfx_s3k51)
					p.secondjump = 2
					p.mo.state = S_PLAY_FALL
					p.charability = CA_NONE
				end
			end
		end
	end
end

//Checking if something was damaged by fang's cork in particular
local function fangLaugh(target, inflictor, source, dmg, dmgtype)
	if inflictor and inflictor.valid and inflictor.info == mobjinfo[MT_CORK] then
		for p in players.iterate do
			if source == p.mo and p and p.mo and p.mo.valid and amIBullied(p.mo.skin) then
				if target and target.player == nil then
					if P_IsObjectOnGround(p.mo) then
						p.startlaff = true
						p.rotx = target.x
						p.roty = target.y
					elseif (not P_IsObjectOnGround(p.mo)) and p.pflags & PF_JUMPED then
						//for cheeky cork-jumpers
						p.msg1 = "you dumb cretin. you fool."
						p.msg2 = "you absolute buffoon. you bumbling idiot."
						S_StartSound(p.mo, sfx_pelo)
						P_StartQuake(6*FRACUNIT, 9)
						local peloboom = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_PELOBOOM)
						peloboom.spritexscale = FRACUNIT/3
						peloboom.spriteyscale = FRACUNIT/3
						p.mo.z = $+FRACUNIT
						p.delObj = true
						p.idied = true
						print("\3 \133" .. p.name .. " tried to fire their gun without laughing")
					end
				end
			end
		end
	end
	return
end

//Making fang reset his laughter if damaged
local function fLaughDamage(target, inflictor, source, dmg, dtype)
	if target.skin == "fang" then
		if target and target.valid and target.player and target.player.startlaff then
			target.player.lafftimer = 70
			if (not target.player.idied) then
				target.player.pflags = $ & ~PF_FULLSTASIS
				target.flags = $ & ~MF_NOGRAVITY
			end
		end
	end
	return false
end

//Prventing bullying deaths from happening after a respawn
local function postDeathDeathPrevention(p)
	if p.idied then p.idied = false end
	if p and p.mo and p.mo.valid then
		p.firstmessage = false
		p.secondmessage = false
		p.texTimer = 0
		p.lastmomz = 0
		p.mo.flags = $ & ~MF_NOGRAVITY
		p.powers[pw_ignorelatch] = 0
		p.pflags = $ & ~PF_FULLSTASIS & ~PF_JUMPED
		p.mo.flags = $ & ~MF_NOGRAVITY
		p.mo.state = S_PLAY_STND
		p.laffangle = nil
		p.lafftimer = nil
		p.startlaff = nil
	end
end

//Yarrr
addHook("AbilitySpecial", abilityBullying)
addHook("PlayerThink", bullyThinker)
addHook("PlayerSpawn", postDeathDeathPrevention)
addHook("MobjThinker", statueThinker, MT_STATUE)
addHook("MobjThinker", newNumberThinker, MT_DROWNNUMBERS)
addHook("MobjDamage", fangLaugh)
addHook("MobjDamage", fLaughDamage, MT_PLAYER)
addHook("PlayerCanDamage", preventDamage)
addHook("PlayerQuit", dontBreakAnything)
//addHook("JumpSpinSpecial", superDeath)
addHook("MapChange", mapchangeAntideath)
addHook("NetVars", bullySync)

//Console command for listing bullied skins
COM_AddCommand("whosbullied", function(p, arg)
	CONS_Printf(p, "\x82 Skins currently being bullied: ")
	for i, skin in ipairs(bullyList) do
		CONS_Printf(p, "\x87 - " .. skin)
	end
end)

//Console command for adding new bullied skins
COM_AddCommand("addbully", function(p, arg)
	if arg then
		local skinadded = false
		local alreadyadded = false
		local iterateadded = false
		arg = arg:lower(arg)
		arg = arg:gsub("%s+", "")
		if arg == "metal" then arg = "metalsonic" end //For he lazy
		if arg == "current" then 
			if p.mo and p.mo.valid then 
				arg = p.mo.skin
			else
				arg = "sorrynothing"
			end
		end
		if arg == "all" then //Iterate through all available skins and add all missing
			for skin in skins.iterate do
				for i, addedskins in ipairs(bullyList) do
					if addedskins == skin.name then iterateadded = true end
				end
				if not iterateadded then
					table.insert(bullyList, skin.name)
				end
				iterateadded = false
			end
			CONS_Printf(p, "\x82 All characters are now being bullied!")
			for player in players.iterate do
				if player and player.mo and player.mo.valid then
					CONS_Printf(player, "\3\x82 Your character has been added to the bullying list. Have fun!")
				end
			end
		else //Use supplied arg to add specific characters
			for skin in skins.iterate do
				if arg == skin.name then
					for i, addedskins in ipairs(bullyList) do
						if addedskins == arg then
							alreadyadded = true
						end
					end
					if not alreadyadded then
						table.insert(bullyList, arg)
						skinadded = true
					end
				end
			end
			if alreadyadded then CONS_Printf(p, "\x82 This character is already being bullied!")
			elseif skinadded then 
				CONS_Printf(p, "\x82 Character added successfully.")
				for player in players.iterate do
					if player and player.mo and player.mo.valid then
						if player.mo.skin == arg then
							CONS_Printf(player, "\3\x82 Your character has been added to the bullying list. Have fun!")
						end
					end
				end
			else CONS_Printf(p, "\x82 No skin was found with that name.") end
		end
	else
		CONS_Printf(p, "\x82 Used to add skins to be bullied by the mod.")
		CONS_Printf(p, "\x82 Valid options: character skin names, \"all\" to add all characters or")
		CONS_Printf(p, "\x82 \"current\" to add your current character.")
		CONS_Printf(p, "\x82 Usage:")
		CONS_Printf(p, "\x87 	addbully \"[skin name]\"")
		CONS_Printf(p, "\x82 Examples:")
		CONS_Printf(p, "\x87 	addbully \"sonic\"")
		CONS_Printf(p, "\x87 	addbully \"current\"")
		CONS_Printf(p, "\x87 	addbully \"all\"")
	end
end, COM_ADMIN)

//Console command for removing added bullied skins
COM_AddCommand("removebully", function(p, arg)
	if arg then
		local foundandremoved = false
		arg = arg:lower(arg)
		arg = arg:gsub("%s+", "")
		if arg == "metal" then arg = "metalsonic" end
		if arg == "current" then 
			if p.mo and p.mo.valid then 
				arg = p.mo.skin
			else
				arg = "sorrynothing"
			end
		end
		if arg == "all" then
			for i=1, #bullyList do
				table.remove(bullyList)
			end
			CONS_Printf(p, "\x82 All characters are now free from bullying!")
			for player in players.iterate do
				if player.mo.skin == arg or arg == "all" then
					player.cleanup = true
					player.charability = skins[player.mo.skin].ability
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.actionspd = skins[player.mo.skin].actionspd
					CONS_Printf(player, "\3\x82 Your character has been removed from the bullying list.")
				end
			end
		else
			for i, addedskins in ipairs(bullyList) do
				if addedskins == arg then
					table.remove(bullyList, i)
					foundandremoved = true
				end
			end
			if foundandremoved then CONS_Printf(p, "\x82 " .. arg .. " has been removed from the bullying list.")
				for player in players.iterate do
					if player and player.mo and player.mo.valid then
						if player.mo.skin == arg or arg == "all" then
							player.cleanup = true
							player.charability = skins[player.mo.skin].ability
							player.normalspeed = skins[player.mo.skin].normalspeed
							player.actionspd = skins[player.mo.skin].actionspd
							CONS_Printf(player, "\3\x82 Your character has been removed from the bullying list.")
						end
					end
				end
			else CONS_Printf(p, "\x82 No character with that skin name was found in the bullying list.") end
		end
	else
		CONS_Printf(p, "\x82 Used to remove characters from the bullying list.")
		CONS_Printf(p, "\x82 Valid options: character skin names, \"all\" to remove all characters or")
		CONS_Printf(p, "\x82 \"current\" to remove your current character.")
		CONS_Printf(p, "\x82 Usage:")
		CONS_Printf(p, "\x87 	removebully \"[skin name]\"")
		CONS_Printf(p, "\x82 Examples:")
		CONS_Printf(p, "\x87 	removebully \"sonic\"")
		CONS_Printf(p, "\x87 	removebully \"current\"")
		CONS_Printf(p, "\x87 	removebully \"all\"")
	end
end, COM_ADMIN)

//Bullying HUD text
hud.add(function(v,p)
	if not p.mo then return end
	
	if amIBullied(p.mo.skin) then
		if p.firstmessage then
			v.drawString(160, 90, p.msg1, V_SNAPTOBOTTOM, "center")
		end
		if p.secondmessage then
			v.drawString(160, 110, p.msg2, V_SNAPTOBOTTOM, "center")
		end
	end
	
end,"game")